
#include "config/grayScale.glsl"
#include "config/ToneMap.glsl"
#include "config/torchLight.glsl"
#include "config/Activator.glsl"

vec4 nightLight( vec4 set, vec2 uv1){

	                   vec3 nightColor = curve(0.25 * set.rgb);
		                         nightColor *= vec3(0.3, 0.4, 0.6);
		                         nightColor += 0.15;

		                         vec3 Color = mix(curve(0.25 * grayScale(set.rgb)),nightColor, smoothstep(0.0, 0.75, uv1.y));
		                         set.rgb = mix(Color,torch_color(set.rgb, uv1).rgb, pow(uv1.x, 1.0));
						    
return set;}

vec4 sunLight(vec4 set, vec2 uv1){
	
                               if(rain()){
			                     vec3 rainColor = mix(0.9 * grayScale(set.rgb), set.rgb, smoothstep(0.0, 0.75, uv1.y));
			                     set.rgb = mix(rainColor, torch_color(set.rgb, uv1).rgb, pow(uv1.x, 1.0));
			
}else{		
		                        vec4 col =  vec4(4.0, 3.0, 2.0, 1.0) * 0.4;
		                        vec3 intensity = vec3(dot(col.rgb, vec3(1.0)));
		                        vec3 alpha = mix(intensity, col.rgb, 1.1);
		                        vec3 strengh = curve(0.25 * set.rgb) * alpha;
		                                 strengh += 0.1;
		
		                        vec3 colormix = mix(curve(0.25 * grayScale(set.rgb)), strengh, smoothstep(0.0, 0.75, uv1.y));
		                        vec3 torch_bias = mix(torch_color(set.rgb, uv1).rgb, strengh, smoothstep(0.0, 0.55, uv1.y));
		                        set.rgb = mix(colormix, torch_bias, pow(uv1.x, 1.0));}
return set;}

vec4 dayLight(vec4 set,vec2 uv1){

			               
		                           vec3 dayColor = curve(0.25 * set.rgb);
	                                       dayColor *= vec3(1.5,1.4,1.3);
	                                       dayColor += 0.01;

		                           vec3 colormix = mix(curve(0.25 * grayScale(set.rgb)), dayColor, smoothstep(0.0, 0.75, uv1.y));
		                           vec3 torch_bias = mix(torch_color(set.rgb, uv1).rgb, dayColor, smoothstep(0.0, 0.85, uv1.y));
		                           set.rgb = mix(colormix, torch_bias, pow(uv1.x, 1.0));
                                                 
#ifdef FANCY
                                  vec3 n = normalize(cross(dFdx(position.zyx),dFdy(position.zyx)));
                                  float shadowmap = mix(0.0,0.45,smoothstep(0.87 + 0.005,0.87 - 0.05,uv1.y));
                                  float nolight = 1.0-uv1.x;

#ifdef ALPHA_TEST
                                 if(color.a>0.0){ shadowmap = mix(shadowmap,0.35,max(0.0,-n.b)); } else{shadowmap = mix(shadowmap,0.35,max(max(0.0,-n.b),max(0.0,n.b)) );}
#else
#ifdef BLEND
#else
                                 shadowmap = mix(shadowmap,0.35,max(max(0.0,-n.b),max(0.0,n.b)));
#endif
#endif
#endif
                                  set.rgb = mix(set.rgb,vec3(0.09),shadowmap*nolight);                         
return set;}
