vec3 curve(vec3 color){
		             color = max(vec3(0.), color - vec3(0.004));
		             color = (color * (6.3 * color + .5)) / (color * (6.3 * color + 1.7) + 0.06);
return color;}

vec3 ToneMapFilmic(vec3 x){

                      const float a = 2.51f;
                      const float b = 0.035f;
                      const float c = 2.43f;
                      const float d = 0.59f;
                      const float e = 0.15f;

return clamp((x * (a * x + b)) / (x * (c * x + d) + e), 0.0, 1.0);}

float filmic_curve(float x) {
	float A = 0.20;									// Shoulder strength
	float B = 0.30;									// Linear strength
	float C = 0.15 * 1.0;	// Linear angle
	float D = 0.20 * 1.0;			// Toe strength
	float E = 0.02 * 1.0;		// Toe numerator
	float F = 0.30;									// Toe denominator
	return ((x * (A * x + C * B) + D * E) / (x * (A * x + B) + D * F)) - E / F;
}

vec3 Tonemapping(vec3 clr) {
	
		float W = 1.0 / 1.0;
		float Luma = dot(clr, vec3(0.7, 0.5, 0.3));
		vec3 Chroma = clr - Luma;
		clr = (Chroma * 1.0) + Luma;
		clr = vec3(filmic_curve(clr.r), filmic_curve(clr.g), filmic_curve(clr.b)) / filmic_curve(W);
	
	return clr;
}
