
#include "config/ColorCycle.glsl"
#include "config/Noise.glsl"
#include "config/SaturationColor.glsl"
#include "config/Tonemap.glsl"
#include "config/vignette.glsl"
#include "config/waterColor.glsl"
#include "config/Activator.glsl"

void render(inout vec4 set, vec2 uv1){

		                 vec4 transf = texture2D( TEXTURE_1, vec2( 0.0, 1.0));
	                   	float settime = (transf.r - 0.5) / 0.5;
		                 settime = max(-1.0, min(1.0, settime));	

			              if(settime < -0.55){
			             set = nightLight(set, uv1);}

			             else if(settime > -0.55 && settime < 0.3){				
					       set = mix(nightLight(set, uv1), sunLight(set, uv1), smoothstep(-0.55, 0.3, settime));}
			
			             else if(settime > 0.3 && settime < 0.9){
			             set = mix(sunLight(set, uv1), dayLight(set, uv1), smoothstep(0.31, 0.9, settime));}

			             else if(settime > 0.9){
			             set = dayLight(set, uv1);}

                       Saturation(set.rgb);
                       set.rgb *= ToneMapFilmic(set.rgb);                                         
                       if(color.a==0.0){set.rgb *= 0.66;}

                      float cx =(color.r+color.g+color.b)/3.0;
                      watercolor(set);

#ifdef BLEND
if((iswater())||(cx<0.4)){

                      highp float layer1 = smoothstep(100.0,500.0,(worldpos.x*worldpos.x+worldpos.z*worldpos.x)/max(1.0,abs(worldpos.y)));

                      highp float layer2 = (noise(-position.zx-TIME*0.3)+noise(vec2(-position.x+-position.z-TIME,(-position.z+-position.z+TIME)*0.3)))*0.375+0.20;
              
                      vec4 BaseAlpha = vec4(mix(set.rgb*1.2,vec3(set.r+set.g+set.b),0.3),set.a*1.5);

                        float day_f = pow(max(min(1.0-FOG_COLOR.b * 1.2, 1.0), 0.0), 0.5);
                        float night_f = pow(max(min(1.0-FOG_COLOR.r * 1.5, 1.0), 0.0), 1.2);
                        float rain_f = (1.0 - pow(FOG_CONTROL.y, 11.0));

                 vec4 day = vec4(0.35,0.4,0.5,0.2);                 
                 vec4 night = vec4(FOG_COLOR.rgb,0.2);                 
                 vec4 dusk = vec4(0.08,0.0,0.1,0.1)*1.7;                
                 vec4 rain = vec4(FOG_COLOR.rgb,0.2);                                    
                 
                  vec4 water_color = mix(mix(mix(day,dusk,day_f), night, night_f),rain,rain_f);

vec4 specular = mix(set*1.0,mix(mix(mix(water_color,vec4(2.0,1.5,0.5,1.0)*5.0,day_f),water_color,night_f),water_color,rain_f),smoothstep(3.0+abs(worldpos.y)*0.1,0.0,abs(worldpos.z))*smoothstep(0.5,0.75,uv1.y));

                            set = mix(set,mix(BaseAlpha,specular,layer2),layer2*((1.0-layer1)*0.8));
}
#endif

                        set.rgb = mix(set.rgb,vec4(0.6,0.8,1.0,0.0).rgb*0.9*FOG_COLOR.rgb,far);

if(underwater()){

                        highp float layer1 = smoothstep(100.0,500.0,(worldpos.x*worldpos.x+worldpos.z*worldpos.x)/max(1.0,abs(worldpos.y)));

                       highp float layer2 = (noise(-position.zx-TIME*0.3)+noise(vec2(-position.x+-position.z-TIME,(-position.z+-position.z+TIME)*0.3)))*0.375+0.20;

vec4 opacity = texture2D( TEXTURE_0, uv0 )*texture2D( TEXTURE_1, uv1 )*vec4(color.rgb,0.5);
set = opacity;
                            vec4 BaseAlpha = set*1.3;              

                           set *= mix(set,BaseAlpha,layer2*((1.0-layer1)*1.8));
                           //set.rgb = vec4(2.0,2.2,3.0,0.1).rgb*FOG_COLOR.rgb;

}

                            Vignette(set.rgb);

}