// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "fragmentVersionSimple.h"
#include "uniformWorldConstants.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"
#include "uniformRenderChunkConstants.h"

varying vec4 color;
varying highp vec3 po;
varying vec4 cloudColor;
varying float cr;



#include "config/Fbm.glsl"

void main() {

highp float f = fbm(1.0*po.xz);

highp float cover = CLOUD_OCTAVES;
highp float sharpness = CLOUD_SHARPNESS;

highp float c = f - (1.0 - cover);
if ( c < 0.0 )
	c = 0.0;
	
f = 1.0 - (pow(sharpness, c));

vec4 cloud = cloudColor;
cloud.a *= (f)*0.8;

vec4 result = mix(color,cloud,cloud.a);

gl_FragColor = result;
gl_FragColor = mix(gl_FragColor,FOG_COLOR,cr);


}
