// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "vertexVersionSimple.h"

#include "uniformWorldConstants.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"

attribute mediump vec4 POSITION;
attribute vec4 COLOR;

varying vec4 color;
varying highp vec3 po;
varying vec4 cloudColor;
varying float cr;

const float fogNear = 0.0;

void main()
{

POS4 worldPosed = WORLD * POSITION;
vec4 pos = POSITION;

pos.y -=(0.1,0.2,clamp(length(POSITION.xyz),0.0,4.0))*0.5-0.11;
gl_Position = WORLDVIEWPROJ * pos;
po = POSITION.xyz;

vec4 fc = FOG_COLOR;
vec4 cc = CURRENT_COLOR;
cr = COLOR.r;

float day_c = pow(max(min(1.0-cc.b * 1.2, 1.0), 0.0), 0.5);
float night_c = pow(max(min(1.0-cc.r * 1.5, 1.0), 0.0), 1.2);
float day_f = pow(max(min(1.0-fc.b * 1.2, 1.0), 0.0), 0.5);
float night_f = pow(max(min(1.0-fc.r * 1.5, 1.0), 0.0), 1.2);
float rain_f = (1.0 - pow(FOG_CONTROL.y, 11.0));

vec4 day_color = vec4(0.0,0.128,0.255,2.5) * 3.5;
vec4 night_color = vec4(0.05,0.05,0.08,1.0);
vec4 sun_color = vec4(0.0,0.1,0.4,1.0);
vec4 rain_color = vec4(0.15,0.15,0.15,0.1);

vec4 colors = mix(mix(mix(day_color, sun_color, day_c), night_color, night_c),rain_color, rain_f);


vec4 day = vec4(3.2,3.2,3.2,0.001);
vec4 night = vec4(0.5,0.5,0.5,0.1);
vec4 dusk = vec4(3.0,0.0,-0.5,0.3)*1.8;
vec4 rain = vec4(-0.5,-0.5,-0.5,fc)*1.0;

vec4 color_cloud = mix(mix(mix(day, dusk, day_c), night, night_c),rain, rain_f);

cloudColor = mix(color_cloud,fc,COLOR.r);
color = mix(colors,fc,COLOR.r);

vec3 underwatercolor = vec3(1.4, 3.0, 4.2) * 1.3; 

if((FOG_CONTROL.x < 0.15)){
color.rgb*= underwatercolor;} 
}
