// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "vertexVersionCentroidUV.h"

#include "uniformWorldConstants.h"

attribute POS4 POSITION;
attribute vec2 TEXCOORD_0;
varying POS4 vpos;
varying POS3 pos;

uniform vec4 FOG_COLOR;
uniform vec2 FOG_CONTROL;

void main()
{
    float malam = pow(max(min(1.0-FOG_COLOR.r*1.5,1.0),0.0),1.2);
    vec4 size = vec4(11., 1.2, 11., 1.2);
    size.xz /= mix( 1., 5., malam );
    gl_Position = WORLDVIEWPROJ * (POSITION * size);

    uv = TEXCOORD_0;
    vpos = POSITION * WORLDVIEWPROJ;
    pos = POSITION.xyz;
}